package com.ynet.life.loaf.action;

import com.ynet.gene.core.Context;
import com.ynet.gene.core.GENEException;
import com.ynet.gene.data.InvalidArgumentException;
import com.ynet.gene.data.ObjectNotFoundException;
import com.ynet.life.action.LifeJDBCAction;
import com.ynet.life.base.LifeDBAccess;
import com.ynet.life.base.Trace;
import com.ynet.life.exception.TranFailException;
import com.ynet.life.loaf.DataMappingProvider;
import com.ynet.life.loaf.TableConfig;
import java.sql.Connection;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/* loaded from: com_ynet_life_loaf_action.jar:com/ynet/life/loaf/action/UpdateChangedDataAction.class */
public class UpdateChangedDataAction extends LifeJDBCAction {
    private int opType;
    private String businessCodeField;
    private String businessCode;
    protected String filterSubBusinessCodeField;
    private boolean throwException = true;
    protected Map filterSubBusinessCodeMap = new HashMap();

    public String execute(Context context) throws GENEException {
        String str;
        String str2;
        Connection connection = null;
        try {
            try {
                if (this.businessCodeField != null) {
                    str = (String) context.get(this.businessCodeField);
                } else {
                    str = this.businessCode;
                }
                TableConfig tableConfig = DataMappingProvider.getTableConfig(str);
                Connection connection2 = LifeDBAccess.getConnection(getDataSource());
                connection = connection2;
                DataMappingProvider.doTableOperation(connection2, tableConfig, this.opType, context);
                List subBusinessList = tableConfig.getSubBusinessList();
                int subSize = subBusinessList.size();
                if (this.filterSubBusinessCodeField != null && this.filterSubBusinessCodeField.trim().length() > 0) {
                    if (((String) context.getDataValue(this.filterSubBusinessCodeField)) == null) {
                        str2 = "";
                    } else {
                        str2 = (String) context.getDataValue(this.filterSubBusinessCodeField);
                    }
                    String[] filterSubBusinessCode = str2.split("@");
                    for (int i = 0; i < filterSubBusinessCode.length; i++) {
                        this.filterSubBusinessCodeMap.put(filterSubBusinessCode[i], filterSubBusinessCode[i]);
                    }
                }
                for (int i2 = 0; i2 < subSize; i2++) {
                    String subBusinessCode = (String) subBusinessList.get(i2);
                    if (!this.filterSubBusinessCodeMap.containsKey(subBusinessCode)) {
                        DataMappingProvider.doTableOperation(connection, DataMappingProvider.getTableConfig(subBusinessCode), this.opType, context);
                    }
                }
                LifeDBAccess.releaseConnection(getDataSource(), connection);
                return "0";
            } catch (ObjectNotFoundException e) {
                Trace.logError("LOAF", e.getMessage(), e);
                throw new TranFailException("EBLN0000", e);
            } catch (InvalidArgumentException e2) {
                Trace.logError("LOAF", e2.getMessage(), e2);
                throw new TranFailException("EBLN0000", e2);
            } catch (TranFailException ex) {
                Trace.logError("LOAF", String.valueOf(ex.getErrorCode()) + "：" + ex.getMessage(), ex);
                handleException(context, ex, this.throwException);
                LifeDBAccess.releaseConnection(getDataSource(), connection);
                return "0";
            }
        } catch (Throwable th) {
            LifeDBAccess.releaseConnection(getDataSource(), connection);
            throw th;
        }
    }

    public void setOpType(String opType) {
        this.opType = DataMappingProvider.getOpType(opType);
    }

    public void setBusinessCodeField(String businessCodeField) {
        this.businessCodeField = businessCodeField;
    }

    public void setBusinessCode(String businessCode) {
        this.businessCode = businessCode;
    }

    public void setThrowException(String throwException) {
        this.throwException = Boolean.valueOf(throwException).booleanValue();
    }

    public String getFilterSubBusinessCodeField() {
        return this.filterSubBusinessCodeField;
    }

    public void setFilterSubBusinessCodeField(String filterSubBusinessCodeField) {
        this.filterSubBusinessCodeField = filterSubBusinessCodeField;
    }
}
